/***************************************************************************
 *                          Zanoza Modeler v2.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                Copyright (c) 2002-2008 Zanoza Software.                 *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg Melashenko
 *--------------------------------------------------------------------------
 * @purpose:  Declaration of the class ICamera
 *--------------------------------------------------------------------------
 * @created: Saturday, March 08, 2003 16:47:11
 */

#if !defined(ICamera_h_included)
#define ICamera_h_included
//forward declaration of this class might require
namespace scene
{ class ICamera; };
#include <zmodeler.h>
#include <scene/zmSceneTypes.h>

namespace scene
{
  
  class ICamera : public ZUnknown
  {
  public:
    virtual ZRESULT getUp(ZVector& upVect)=0;
    virtual ZRESULT setUp(ZVector upVect)=0;
    virtual ZRESULT getDirection(ZVector& dir)=0;
    virtual ZRESULT setDirection(ZVector dir)=0;
    virtual ZRESULT getFOV(ZAngle& fov)=0;
    virtual ZRESULT setFOV(ZAngle fov)=0;
    virtual ZRESULT getFrontClip(float& clipDist)=0;
    virtual ZRESULT setFrontClip(float clipDist)=0;
    virtual ZRESULT getBackClip(float& clip)=0;
    virtual ZRESULT setBackClip(float clip)=0;
  
  };//class ICamera
};//scene

#endif
